- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Ipopt::CompoundSymMatrix Class Reference

Class for symmetric matrices consisting of other matrices. More...

`#include <IpCompoundSymMatrix.hpp>`

Inheritance diagram for Ipopt::CompoundSymMatrix:

[legend]
Collaboration diagram for Ipopt::CompoundSymMatrix:

[legend]
List of all members.

## Public Member Functions
void | SetComp (Index irow, Index jcol, const Matrix &matrix)
| Method for setting an individual component at position (irow, icol) in the compound matrix.
void | SetCompNonConst (Index irow, Index jcol, Matrix &matrix)
| Non const version of the same method.
SmartPtr< const Matrix > | GetComp (Index irow, Index jcol) const
| Method for retrieving one block from the compound matrix.
SmartPtr< Matrix > | GetCompNonConst (Index irow, Index jcol)
| Non const version of GetComp.
SmartPtr< CompoundSymMatrix > | MakeNewCompoundSymMatrix () const
| Method for creating a new matrix of this specific type.
Index | NComps_Dim () const
| Number of block rows and columns.
Constructors / Destructors
| CompoundSymMatrix (const CompoundSymMatrixSpace *owner_space)
| Constructor, taking only the number for block components into the row and column direction.
| ~CompoundSymMatrix ()
| Destructor.
## Protected Member Functions
Methods overloaded from matrix
virtual void | MultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply.
virtual bool | HasValidNumbersImpl () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan).
virtual void | PrintImpl (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent, const std::string &prefix) const
| Print detailed information about the matrix.
## Private Member Functions
bool | MatricesValid () const
| method to check wether or not the matrices are valid
const Matrix * | ConstComp (Index irow, Index jcol) const
| Internal method to return a const pointer to one of the comps.
Matrix * | Comp (Index irow, Index jcol)
| Internal method to return a non-const pointer to one of the comps.
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| CompoundSymMatrix ()
| Default Constructor.
| CompoundSymMatrix (const CompoundSymMatrix &)
| Copy Constructor.
void | operator= (const CompoundSymMatrix &)
| Overloaded Equals Operator.
## Private Attributes
std::vector< std::vector< SmartPtr< Matrix > > > | comps_
| Vector of vectors containing the components.
std::vector< std::vector< SmartPtr< const Matrix > > > | const_comps_
| Vector of vectors containing the const components.
const CompoundSymMatrixSpace * | owner_space_
| Copy of the owner_space ptr as a CompoundSymMatrixSpace.
bool | matrices_valid_
| boolean indicating if the compound matrix is in a "valid" state

## Detailed Description

Class for symmetric matrices consisting of other matrices.

Here, the lower left block of the matrix is stored.

Definition at line 24 of file IpCompoundSymMatrix.hpp.

## Constructor & Destructor Documentation

Ipopt::CompoundSymMatrix::CompoundSymMatrix | ( | const CompoundSymMatrixSpace * | owner_space | ) |

Constructor, taking only the number for block components into the row and column direction.

The owner_space has to be defined, so that at each block row and column contain at least one non-NULL component.

Ipopt::CompoundSymMatrix::~CompoundSymMatrix | ( |  | ) |

Destructor.

Ipopt::CompoundSymMatrix::CompoundSymMatrix | ( |  | ) | `[private]`

Default Constructor.

Ipopt::CompoundSymMatrix::CompoundSymMatrix | ( | const CompoundSymMatrix & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

void Ipopt::CompoundSymMatrix::SetComp | ( | Index | irow,
|  | Index | jcol,
|  | const Matrix & | matrix |
| ) |  |  |

Method for setting an individual component at position (irow, icol) in the compound matrix.

The counting of indices starts at 0. Since this only the lower left components are stored, we need to have jcol<=irow, and if irow==jcol, the matrix must be a SymMatrix

void Ipopt::CompoundSymMatrix::SetCompNonConst | ( | Index | irow,
|  | Index | jcol,
|  | Matrix & | matrix |
| ) |  |  |

Non const version of the same method.

SmartPtr<const Matrix> Ipopt::CompoundSymMatrix::GetComp | ( | Index | irow,
|  | Index | jcol |
| ) |  |  | const`[inline]`

Method for retrieving one block from the compound matrix.

Since this only the lower left components are stored, we need to have jcol<=irow

Definition at line 54 of file IpCompoundSymMatrix.hpp.

References ConstComp().

SmartPtr<Matrix> Ipopt::CompoundSymMatrix::GetCompNonConst | ( | Index | irow,
|  | Index | jcol |
| ) |  |  | `[inline]`

Non const version of GetComp.

You should only use this method if you are intending to change the matrix you receive, since this CompoundSymMatrix will be marked as changed.

Definition at line 62 of file IpCompoundSymMatrix.hpp.

References Comp(), and Ipopt::TaggedObject::ObjectChanged().

SmartPtr< CompoundSymMatrix > Ipopt::CompoundSymMatrix::MakeNewCompoundSymMatrix | ( |  | ) | const`[inline]`

Method for creating a new matrix of this specific type.

Definition at line 275 of file IpCompoundSymMatrix.hpp.

References Ipopt::CompoundSymMatrixSpace::MakeNewCompoundSymMatrix(), and owner_space_.

Index Ipopt::CompoundSymMatrix::NComps_Dim | ( |  | ) | const

Number of block rows and columns.

Referenced by Comp(), and ConstComp().

virtual void Ipopt::CompoundSymMatrix::MultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y |
| ) |  |  | const`[protected, virtual]`

Matrix-vector multiply.

Computes y = alpha * Matrix * x + beta * y

Implements Ipopt::Matrix.

virtual bool Ipopt::CompoundSymMatrix::HasValidNumbersImpl | ( |  | ) | const`[protected, virtual]`

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

Reimplemented from Ipopt::Matrix.

virtual void Ipopt::CompoundSymMatrix::PrintImpl | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent,
|  | const std::string & | prefix |
| ) |  |  | const`[protected, virtual]`

Print detailed information about the matrix.

Implements Ipopt::Matrix.

void Ipopt::CompoundSymMatrix::operator= | ( | const CompoundSymMatrix & |  | ) | `[private]`

Overloaded Equals Operator.

bool Ipopt::CompoundSymMatrix::MatricesValid | ( |  | ) | const`[private]`

method to check wether or not the matrices are valid

const Matrix* Ipopt::CompoundSymMatrix::ConstComp | ( | Index | irow,
|  | Index | jcol |
| ) |  |  | const`[inline, private]`

Internal method to return a const pointer to one of the comps.

Definition at line 134 of file IpCompoundSymMatrix.hpp.

References comps_, const_comps_, DBG_ASSERT, Ipopt::GetRawPtr(), Ipopt::IsValid(), and NComps_Dim().

Referenced by GetComp().

Matrix* Ipopt::CompoundSymMatrix::Comp | ( | Index | irow,
|  | Index | jcol |
| ) |  |  | `[inline, private]`

Internal method to return a non-const pointer to one of the comps.

Definition at line 149 of file IpCompoundSymMatrix.hpp.

References comps_, const_comps_, DBG_ASSERT, Ipopt::GetRawPtr(), Ipopt::IsNull(), Ipopt::IsValid(), and NComps_Dim().

Referenced by GetCompNonConst().

## Member Data Documentation

std::vector<std::vector<SmartPtr<Matrix> > > Ipopt::CompoundSymMatrix::comps_`[private]`

Vector of vectors containing the components.

Definition at line 119 of file IpCompoundSymMatrix.hpp.

Referenced by Comp(), and ConstComp().

std::vector<std::vector<SmartPtr<const Matrix> > > Ipopt::CompoundSymMatrix::const_comps_`[private]`

Vector of vectors containing the const components.

Definition at line 122 of file IpCompoundSymMatrix.hpp.

Referenced by Comp(), and ConstComp().

const CompoundSymMatrixSpace* Ipopt::CompoundSymMatrix::owner_space_`[private]`

Copy of the owner_space ptr as a CompoundSymMatrixSpace.

Reimplemented from Ipopt::SymMatrix.

Definition at line 125 of file IpCompoundSymMatrix.hpp.

Referenced by MakeNewCompoundSymMatrix().

bool Ipopt::CompoundSymMatrix::matrices_valid_`[mutable, private]`

boolean indicating if the compound matrix is in a "valid" state

Definition at line 128 of file IpCompoundSymMatrix.hpp.

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Ipopt-3.2.1/Ipopt/src/LinAlg/IpCompoundSymMatrix.hpp